#ifndef __BIZ_CLIENT_STATE_H__
#define __BIZ_CLIENT_STATE_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: BIZclientState
//
// Description:
//
// BIZclientState class.
//
// Date:   Saturday, May 19th, 2007 @ 09:29:15 PM
// Revision: $Revision: 1.3 $
//
// Last Edit Date: $Date: 2007/06/20 16:21:18 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/BIZ/BIZclientState.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMstring.h>

enum BIZstate
{ 
   BIZ_NEED_TO_POLL_APP,
   BIZ_WAITING_FOR_ACK
};

class BIZclientState 
{
public:
   BIZclientState();
   // POD so default copy constructor works and assignment operator work
   // This is non-virtual because we are assuming no classes will inherit from this class.
   ~BIZclientState();

   const CHMstring& messageId() const;
   void setMessageId(const CHMstring& MessageId);

   const CHMstring& message() const;
   void setMessage(const CHMstring& Message);
   
   // Seconds since 1971 by which we expect an ACKnowledgment.
   CHMuint64 ackTimeout() const;
   void setAckTimeout(CHMuint64 NewValue);

   BIZstate currentState() const;
   void setCurrentState(BIZstate NewState);

private:
   CHMstring MessageId;
   CHMstring Message;
   CHMuint64 AckTimeout;
   BIZstate  CurrentState;
};

#endif // end of defensive include
