//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: BIZutils
//
// Description:
//
// Implementation
//
// Date:   Saturday, May 19th, 2007 @ 09:39:55 PM
// Revision: $Revision: 1.4 $
//
// Last Edit Date: $Date: 2007/06/20 16:21:18 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/BIZ/BIZutils.cpp,v $
//---------------------------------------------------------------------------
#include "BIZprecomp.h"
#pragma hdrstop

#include "BIZutils.h"
#include "BIZclientState.h"
#include <SERV/SERVostream.h>
#include <SERV/SERVutils.h>

#include <time.h>

CHMboolean BIZfetchMessage(BIZclientState& ClientState)
{
   if (rand() % 10 != 0)
   {
      // We only have a message one in 10 times.
      return false;
   }
   CHMstring MessageId;
   SERVgetDateTimeAsString(MessageId);

   CHMstring Message =
      "MSH|^~\\&|MESA_ADT|XYZ_ADMITTING|MESA_IS|XYZ_HOSPITAL|" + MessageId + "||ADT^A04|" + MessageId + "|P|2.3.1||||||||\r"
      "EVN||200004211000||||200004210950\r"
      "PID|||583020^^^ADT1||REYNOLDS^MALCOLM||19710321|M||AI|SERENITY^^FIREFLY CLASS CARGO SHIP|||||||20-98-1701||||||||||||\r";

   ClientState.setMessage(Message);
   ClientState.setMessageId(MessageId);
   return true;
}

void BIZsetAckTimeOut(BIZclientState& ClientState, CHMint32 TimeoutInSeconds)
{
   ClientState.setAckTimeout(::time(NULL) + TimeoutInSeconds);
   ClientState.setCurrentState(BIZ_WAITING_FOR_ACK);
}

CHMboolean BIZisTimedOut(BIZclientState& ClientState)
{
   return (::time(NULL) > ClientState.ackTimeout());
}

void BIZconfimMessageSend(BIZclientState& ClientState, SERVostream& Log)
{
   Log << "Marking message " << ClientState.messageId().c_str() << " as sent." << newline;
   Log << "TODO (this is just pretend - code needs to be written to actually alter a flag on the database used to generate the messages." << newline << flush;
   ClientState.setCurrentState(BIZ_NEED_TO_POLL_APP);
}

void BIZprocessMessage(const CHMstring& Message, SERVostream& Log)
{
   // We process the message here. For example, we can manually invoke 
   // the Chameleon engine to parse the message.
   Log << "TODO - Process the message!" << newline << flush;
}
