#ifndef __CHM_CLIENT_H__
#define __CHM_CLIENT_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMclient
//
// Description:
//
// The client object which receives network and timer events
//
// Date:   Wed 05/17/2007
// Revision: $Revision: 1.2 $
//
// Last Edit Date: $Date: 2007/06/15 20:58:13 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/ClientService/CHMclient.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>
#include <CHM/CHMllpClient.h>
#include <SERV/SERVtimer.h>
#include <BIZ/BIZclientState.h>

class SERVostream;

class CHMclient
: public CHMllpClient,
  public SERVtimer
{
public:
   CHMclient() {}
   virtual ~CHMclient() {}

   // These are the CHMllpClient events
   virtual void OnConnected();
   virtual void OnClosed();
   virtual void OnMessageReceived(const char* Message);
   virtual void OnErrorReceived(const char* Description, CHMint32 Code);
   virtual void OnDataIgnored(const char* Data);

   // This is the SERVtimer event
   virtual void onTimeout();

private:
   BIZclientState ClientState;

   CHMclient(const CHMclient& Orig); // Copy
   CHMclient& operator=(const CHMclient& Orig); // Assignment
};

#endif // end of defensive include
