#ifndef __SERV_EVENT_H__
#define __SERV_EVENT_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: SERVevent
//
// Description:
//
// Collection of non member functions to generate events for the event log.
//
// Date:   Wed 05/17/2007
// Revision: $Revision: 1.2 $
//
// Last Edit Date: $Date: 2007/06/15 20:58:14 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/SERV/SERVevent.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>

class SERVserver;

// Adds an event source to the registry for logging events.
// The source name is typically the name of the service.
void SERVaddEventSource(const CHMstring& SourceName, const CHMstring& ServiceFilePath);
void SERVaddEventSource(const SERVserver& Server);

void SERVremoveEventSource(const CHMstring& SourceName);
void SERVremoveEventSource(const SERVserver& Server);

enum SERVsystemLogSeverity
{
   SERV_EMERGENCY,   // WIN32: Error
   SERV_ALERT,       // WIN32: Error
   SERV_CRITICAL,    // WIN32: Error
   SERV_ERROR,       // WIN32: Error
   SERV_WARNING,     // WIN32: Warning
   SERV_NOTICE,      // WIN32: Information
   SERV_INFO,        // WIN32: Information
   SERV_DEBUG        // WIN32: Information
};

// This puts a message into the event log (WIN32), it should be used *very* sparingly!
// This function may throw exceptions.
void SERVsystemLog(const CHMstring& SourceName, const CHMstring& LogLine, SERVsystemLogSeverity Severity);
void SERVsystemLog(const SERVserver& Server, const CHMstring& LogLine, SERVsystemLogSeverity Severity);



#endif // end of defensive include
