#ifndef __SERV_PRECOMP_H__
#define __SERV_PRECOMP_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Description:
//
// Precompiled header file for the SERV library.
//
// Date:     Friday, May 18th, 2007 @ 04:15:27 PM
// Revision: $Revision: 1.2 $ 
//
// Last Edit Date: $Date: 2007/06/15 20:58:14 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/SERV/SERVprecomp.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include <stdlib.h>

#ifdef WIN32
#   define WIN32_LEAN_AND_MEAN
#   include <windows.h>
#   include <winsvc.h>
#endif

#define SERV_THROW_ERROR(Message, Number)\
{\
   CHMstring ErrorString = Message;\
   throw CHMerror(ErrorString.c_str(), __LINE__, __FILE__, (long)Number);\
}

// The next macro is very handy.  It will build a CHMerror
// exception and throw it.  Any time that you see a WIN32 API
// function that tells you to use GetLastError to retrieve the
// error code, simply running this macro is an easy way to
// obtain the error description using FormatMessage and GetLastError.
// i.e.
// if (WIN32 API Call Returns Failure Code)
// {
//    CHM_THROW_WIN32_ERROR("during ServiceCreate call for " << ServiceName);
// }
// The above should throw a CHMerror object that says something along the lines of:
//    Error during ServiceCreate call for XYZ on line 23 of CHMclient.cpp:
//    Windows reported that blah blah blah happened.
#define SERV_THROW_WIN32_ERROR(Message) { SERVthrowSystemError(Message, __LINE__, __FILE__ ); }

#define SERV_THROW_STRERROR(Message)\
{\
   CHMstring ErrorString(Message);\
   ErrorString += ": ";\
   ErrorString += strerror(errno);\
   throw CHMerror(ErrorString.c_str(), __LINE__, __FILE__, errno);\
}

#define SERV_EXITCONDITION(Condition) if (!(Condition)) { SERVexitCondition( #Condition, __FILE__, __LINE__, NULL); }

#endif // end of defensive include
