#ifndef __SERV_SERVICE_MANAGER_H__
#define __SERV_SERVICE_MANAGER_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: SERVserviceManager
//
// Description:
//
// Class which encapsulates a C++ interface to the Windows
// SERVICE CONTROL MANAGER.
//
// Date:   Wed 05/17/2007
// Revision: $Revision: 1.2 $
//
// Last Edit Date: $Date: 2007/06/15 20:58:14 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/SERV/SERVserviceManager.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>

class CHMstring;
class SERVserviceManagerPrivate;
class SERVservice;

class SERVserviceManager
{
public:
   SERVserviceManager();
   ~SERVserviceManager();

   CHMboolean doesServiceExist(const CHMstring& ServiceName) const;

   // Create service: If the service exists already then this function will throw
   // an exception.
   SERVservice& createService(const CHMstring& ServiceName, CHMboolean StartAutomatically);

   // Un-install this service.
   void removeService(const CHMstring& ServiceName);

   // If the service does not exist then this function will throw an exception.
   SERVservice& service(const CHMstring& ServiceName);

   friend class SERVservice;

private:
   void* handle();

   SERVserviceManagerPrivate* pMember;
   SERVserviceManager(const SERVserviceManager& Orig);
   SERVserviceManager& operator=(const SERVserviceManager& Orig);
};

#endif // end of defensive include
