#ifndef __SERV_SINK_H__
#define __SERV_SINK_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: SERVsink
//
// Description:
//
// This is the base class for all objects that can act as
// a data sink.
//
// SERVostreams can be used to stream data to SERVsinks
// using the << operator.
//
// Subclasses only need to implement the write() method
// found on this interface.
//
// Date:   November 12, 2004
// Revision: $Revision: 1.2 $
//
// Last Edit Date: $Date: 2007/06/15 20:58:14 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/SERV/SERVsink.h,v $
//---------------------------------------------------------------------------
#include <CHM/CHMminimumInclude.h>

class SERVsink
{
public:
   SERVsink() {}
   virtual ~SERVsink() {}

   // write() should return the amount of bytes
   // actually written from cpBuffer.
   virtual CHMuint32 write( const void* cpBuffer, 
                            CHMuint32 SizeOfBuffer ) = 0;
   virtual void flush() {}
   virtual void onEndStream() {}
};

#endif // end of defensive include
