//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: SERVsinkStandard
//
// Description:
//
// Implementation
//
// Date:   Fri 01/16/2004 
// Revision: $Revision: 1.2 $
//
// Last Edit Date: $Date: 2007/06/15 20:58:14 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/SERV/SERVsinkStandard.cpp,v $
//---------------------------------------------------------------------------
#include "SERVprecomp.h"
#pragma hdrstop

#ifdef WIN32
   #include <io.h>
   #include <FCNTL.h>
#endif
#include "SERVsinkStandard.h"

CHMuint32 SERVsinkStandardOut::write(const void* cpBuffer, CHMuint32 SizeOfBuffer)
{
   if (SizeOfBuffer)
   {      
      fwrite(cpBuffer, 1, SizeOfBuffer, stdout);
   }

   return SizeOfBuffer;
}

void SERVsinkStandardOut::flush()
{
   fflush(stdout);
}

#ifdef WIN32
CHMuint32 SERVsinkStandardOut::STDOUT = _fileno(stdout);
void SERVsinkStandardOut::setBinaryMode(CHMboolean Set)
{
   // Saw this on http://www.willus.com/mingw/_binary.shtml
   if (Set)
   {
      _setmode(SERVsinkStandardOut::STDOUT, _O_BINARY);
   }
   else
   {
      _setmode(SERVsinkStandardOut::STDOUT, _O_TEXT);
   }
}
#else
void SERVsinkStandardOut::setBinaryMode(CHMboolean Set)
{
   // Not needed in Unix
}
#endif

CHMuint32 SERVsinkStandardErr::write(const void* cpBuffer, CHMuint32  SizeOfBuffer)
{
   // TODO - error checking, thread safety...
   if (SizeOfBuffer)
   {
      fwrite(cpBuffer, 1, SizeOfBuffer, stderr);   
   }

   return SizeOfBuffer;
}

void SERVsinkStandardErr::flush()
{
   // TODO - error checking, thread safety...
   fflush(stderr);
}

#ifdef WIN32
CHMuint32 SERVsinkStandardErr::STDERR = _fileno(stderr);
void SERVsinkStandardErr::setBinaryMode(CHMboolean Set)
{
   if (Set)
   {
      _setmode(SERVsinkStandardErr::STDERR, _O_BINARY);
   }
   else
   {
      _setmode(SERVsinkStandardErr::STDERR, _O_TEXT);
   }
}
#else
void SERVsinkStandardErr::setBinaryMode(CHMboolean Set)
{
   // Not needed in Unix
}
#endif
