#ifndef __SERV_SINK_STANDARD_H__
#define __SERV_SINK_STANDARD_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: SERVsinkStandard
//
// Description:
//
// SERVsink objects for standard out and standard error and also
// a trace sink for use in WIN32
//
// Date:   Fri 01/16/2004 
// Revision: $Revision: 1.2 $
//
// Last Edit Date: $Date: 2007/06/15 20:58:14 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/SERV/SERVsinkStandard.h,v $
//---------------------------------------------------------------------------

#include "SERVsink.h"

class SERVsinkStandardOut : public SERVsink
{
public:
   SERVsinkStandardOut() {}
   virtual ~SERVsinkStandardOut() {}

   virtual CHMuint32 write(const void* cpBuffer, 
                           CHMuint32   SizeOfBuffer);
   virtual void flush();

   // We only need this on Windows. Unix does not do translations.
#ifdef WIN32
   static CHMuint32 STDOUT;
#endif
   static void setBinaryMode(CHMboolean Set=true);
};

class SERVsinkStandardErr : public SERVsink
{
public:
   SERVsinkStandardErr() {}
   virtual ~SERVsinkStandardErr() {}

   virtual CHMuint32 write(const void* cpBuffer, 
                           CHMuint32  SizeOfBuffer);
   virtual void flush();   

   // We only need this on Windows. Unix does not do translations.
#ifdef WIN32
   static CHMuint32 STDERR;
#endif
   static void setBinaryMode(CHMboolean Set=true);
};

#endif // end of defensive include
