#ifndef __SERV_UTILS_H__
#define __SERV_UTILS_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: SERVutils
//
// Description:
//
// SERVutils class.
//
// Date:   Friday, May 18th, 2007 @ 04:16:24 PM
// Revision: $Revision: 1.3 $
//
// Last Edit Date: $Date: 2007/06/15 20:58:14 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/SERV/SERVutils.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>
#include <CHM/CHMstring.h>

void SERVfullExecutableFileName(CHMstring& FileName);
void SERVgetExecutableFileDirectory(CHMstring& Directory);

void SERVgetDateTimeAsString(CHMstring& DateTimeString);

// Utility function to see if service is installed.
CHMboolean SERVisServiceInstalled(const CHMstring& ServiceName);

void SERVinstallService
(
   const CHMstring& ServiceName,
   const CHMstring& DisplayName,
   const CHMstring& Description = "",
   CHMboolean StartAutomatically = false
);

void SERVuninstallService(const CHMstring& ServiceName);

CHMstring SERVformatWin32Error(long ErrorCode);

void SERVthrowSystemError
(
   const CHMstring& Description,
   CHMuint32 LineNumber = -1,
   const char* FileName = NULL
);

void SERVcheckResult(long Result);

void SERVexitCondition
(
   const char* Condition,
   const char* FileName,
   CHMuint32 LineNo,
   const char* pDescription
);

#endif // end of defensive include
