#ifndef __CHM_SERVER_H__
#define __CHM_SERVER_H__
//---------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMserver
//
// Description:
//
// The server object which receives network and timer events
//
// Date:   Wed 05/17/2007
// Revision: $Revision: 1.2 $
//
// Last Edit Date: $Date: 2007/06/15 20:58:15 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/ServerService/CHMserver.h,v $
//---------------------------------------------------------------------------

#include <CHM/CHMminimumInclude.h>
#include <CHM/CHMllpServer.h>

class SERVostream;

class CHMserver
: public CHMllpServer
{
public:
   CHMserver();
   virtual ~CHMserver() {}

   // These are the CHMllpServer events
   virtual void OnClientConnected(CHMllpConnection& Client);
   virtual void OnClientDisconnected(CHMllpConnection& Client);
   virtual void OnMessageReceived(CHMllpConnection& Client,const char* Message);
   virtual void OnClientErrorReceived(CHMllpConnection& Client, const char* ErrorMessage, CHMint32 ErrorCode);
   virtual void OnErrorReceived(const char* ErrorMessage, CHMint32 Code);
   virtual void OnDataIgnored(CHMllpConnection& Client, const char* Data);

   void sendAckToClient(CHMllpConnection& Client, const char* Message);

private:
   CHMengine AutoAckEngine;  // Engine instance we use for automatic acknowledgments (dynamic).
   CHMengine AutoNackEngine; // Engine instance we use for negative acknowledgments (dynamic).

   CHMserver(const CHMserver& Orig); // Copy
   CHMserver& operator=(const CHMserver& Orig); // Assignment
};

#endif // end of defensive include
