//------------------------------------------------------------------------
// Copyright (C) 1997-2007 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: C++ Server Service Example
//
// Description:
//
// The entry point for the program.
//
// Date:   Wed 05/17/2007
// Revision: $Revision: 1.3 $
//
// Last Edit Date: $Date: 2007/06/15 20:58:15 $
// Source: $Source: /home/cvs/cvsroot/stubcode_templates/c++/ServerService/main.cpp,v $
//---------------------------------------------------------------------------
#include "CHMserverServicePrecomp.h"
#pragma hdrstop

#include <SERV/SERVevent.h>
#include <SERV/SERVostream.h>
#include <SERV/SERVutils.h>
#include "CHMserverService.h"
#include "CHMconstants.h"

int main(int argc, const char** argv)
{
   try
   {
      CHMserverService Service(APP_SERVICE_NAME);

      CHMboolean UnknownFlagPresent = false;
      for (CHMint32 ArgIndex = 1; ArgIndex < argc; ++ArgIndex)
      {
         CHMstring Flag(argv[ArgIndex]);

         if ("--run" == Flag)
         {
            Service.runServerAsNormalProcess();
            return EXIT_SUCCESS;
         }
         else if ("--install" == Flag)
         {
            SERVinstallService(APP_SERVICE_NAME, APP_SERVICE_NAME, APP_SERVICE_DESCRIPTION, false);
            SERVaddEventSource(Service);
            return EXIT_SUCCESS;
         }
         else if ("--uninstall" == Flag)
         {
            SERVuninstallService(APP_SERVICE_NAME);
            SERVremoveEventSource(Service);
            return EXIT_SUCCESS;
         }
         else
         {
            SERVcout << "Unknown flag " << Flag.c_str() << " encountered." << newline << newline << flush;
            UnknownFlagPresent = true;
            break;
         }
      }

      if (UnknownFlagPresent)
      {
         // Show usage.
         SERVcout << APP_SERVICE_NAME << newline << newline
                  << "Usage:" << newline
                  << argv[0] << " [--run] [--install] [--uninstall]" << newline << newline
                  << "Known flags:" << newline
                  << " --run       Execute application via command-line." << newline
                  << " --install   Install the service." << newline
                  << " --uninstall Uninstall the service." << newline << newline << flush;

         return EXIT_FAILURE;
      }
      else
      {
         Service.runServer();
      }

      return EXIT_SUCCESS;
   }
   catch (const CHMerror& Error)
   {
      SERVcerr << Error.Description() << newline << flush;
      return EXIT_FAILURE;
   }
   catch (...)
   {
      SERVcerr << "Unhandled Exception" << newline << flush;
      return EXIT_FAILURE;
   }

   return EXIT_SUCCESS;
}
